on initLesson
  DisableBTNS()
  setRollName(EMPTY)
  set the visible of sprite 48 to 0
  updateStage()
  InitSnakelogic()
  RestoreHilites()
  Set_BACKSprite(47)
  Set_NEXTSprite(46)
  Set_HelpSprite(45)
  Set_SoundSprite(44)
  Set_NOTEPADSprite(43)
  Set_GLOSSARYSprite(42)
  setTimer(30)
  set_MarkSprite(2)
  Set_NavigatorHL(5)
  Set_MainSprite(6)
  Set_IndexSprite(7)
  Set_FindSprite(9)
  Set_TagWDSprite(8)
  repeat with i = 42 to 47
    set the immediate of sprite i to 1
    set the puppet of sprite i to 1
  end repeat
  set the puppet of sprite get_NavigatorHL() to 1
  set the puppet of sprite Get_MarkSprite() to 1
  set the mouseDownScript to "CheckOpenWindow"
  Set_NEXT(1)
end

on InitSubjectSprite
  if Get_ScreenSubject() <> "00" then
    Set_SubjectSprite(39)
    set the puppet of sprite Get_SubjectSprite() to 1
    set the height of sprite Get_SubjectSprite() to integer(line integer(Get_ScreenSubject()) of Get_SubjectHeight())
    UpdateCursors(Get_SubjectSprite(), 4)
  end if
end

on GoToIntro
  if Get_ScreenSubject() <> "00" then
    set theNum to integer(Get_ScreenSubject())
    go(1, "NCS" & Get_ScreenSubject() & "010.GEO")
  end if
end

on Set_SubjectSprite theSp
  global SubjectSprite
  set SubjectSprite to theSp
end

on Get_SubjectSprite
  global SubjectSprite
  return SubjectSprite
end

on Set_SubjectHeight theSp
  global SubjectHeight
  set SubjectHeight to theSp
end

on Get_SubjectHeight
  global SubjectHeight
  return SubjectHeight
end

on CheckForTagWd
  global TagWD, IndexWD, FindWD, WordWD, Find2WD
  if objectp(TagWD) or objectp(IndexWD) or objectp(FindWD) or objectp(Find2WD) or objectp(WordWD) then
    set the cursor of sprite 48 to [400, 401]
  end if
end

on PlaySound theSnd
  global PCDEL
  if Get_PlayDub() then
    sound playFile 2, the pathName & "SND13" & PCDEL & theSnd
  end if
end

on GoMain
  sound stop 2
  SaveSeenScreens()
  go(1, "NC_MM010.GEO")
end

on GoFind
  global FindWD, CDfilePath, PCDEL
  if objectp(FindWD) then
    forget(FindWD)
  end if
  set the cursor of sprite 48 to [400, 401]
  set FindWD to window (CDfilePath & "WDS" & PCDEL & "NC_FIND.GEO")
  set the rect of FindWD to rect(the stageLeft + 221, the stageTop + 4, the stageLeft + 541, the stageTop + 164)
  set the titleVisible of FindWD to 0
  set the modal of FindWD to 1
  open(FindWD)
end

on HideFINDWindow
  global FindWD
  if objectp(FindWD) then
    forget(FindWD)
  end if
end

on closeFindWindow
  global FindWD
  if objectp(FindWD) then
    forget(FindWD)
  end if
  set the cursor of sprite 48 to 0
  tell the stage
    continue()
  end tell
end

on OpenFind2WD theData
  global Find2WD, CDfilePath, PCDEL
  HideFINDWindow()
  set Find2WD to window (CDfilePath & "WDS" & PCDEL & "NC_FIND2.GEO")
  set the rect of Find2WD to rect(the stageLeft + 48, the stageTop + 4, the stageLeft + 541, the stageTop + 212)
  set the titleVisible of Find2WD to 0
  set the modal of Find2WD to 1
  tell Find2WD
    UpdateSelection(theData)
  end tell
  open(Find2WD)
end

on CloseFind2Window
  global Find2WD
  if objectp(Find2WD) then
    forget(Find2WD)
  end if
  set the cursor of sprite 48 to 0
  tell the stage
    continue()
  end tell
end

on GoIndex
  global IndexWD, CDfilePath, PCDEL
  if objectp(IndexWD) then
    forget(IndexWD)
  end if
  set the cursor of sprite 48 to [400, 401]
  set IndexWD to window (CDfilePath & "WDS" & PCDEL & "NC_INDEX.GEO")
  set the rect of IndexWD to rect(the stageLeft + 220, the stageTop + 4, the stageLeft + 541, the stageTop + 276)
  set the titleVisible of IndexWD to 0
  set the modal of IndexWD to 1
  tell IndexWD
    RonenInit()
  end tell
  open(IndexWD)
end

on OpenWordWD theData
  global WordWD, CDfilePath, PCDEL
  HIdeIndexWindow()
  set WordWD to window (CDfilePath & "WDS" & PCDEL & "NC_WORD.GEO")
  set the rect of WordWD to rect(the stageLeft + 48, the stageTop + 4, the stageLeft + 541, the stageTop + 212)
  set the titleVisible of WordWD to 0
  set the modal of WordWD to 1
  tell WordWD
    UpdateSelection(theData)
  end tell
  open(WordWD)
end

on CloseWordWindow
  global WordWD
  if objectp(WordWD) then
    forget(WordWD)
  end if
  set the cursor of sprite 48 to 0
  tell the stage
    continue()
  end tell
end

on HIdeIndexWindow
  global IndexWD
  if objectp(IndexWD) then
    forget(IndexWD)
  end if
end

on CloseIndexWindow
  global IndexWD
  if objectp(IndexWD) then
    forget(IndexWD)
  end if
  set the cursor of sprite 48 to 0
  tell the stage
    continue()
  end tell
end

on GoIndexMovie thekind
  if thekind = "tool" then
    go("Init" & Get_ScreenSubject(), Get_IndexMovie())
  else
    go(1, Get_IndexMovie())
  end if
end

on set_IndexMovie theMoov
  global IndexMovie
  set IndexMovie to theMoov
end

on Get_IndexMovie theMoov
  global IndexMovie
  return IndexMovie
end

on GoTags
  global TagWD, TAGS_DATA, TAGS_TITLES, TAGS_LIST, CDfilePath, PCDEL
  if objectp(TagWD) then
    forget(TagWD)
  end if
  set the cursor of sprite 48 to [400, 401]
  set TagWD to window (CDfilePath & "WDS" & PCDEL & "NC_TAGS.GEO")
  set the rect of TagWD to rect(the stageLeft + 274, the stageTop + 4, the stageLeft + 539, the stageTop + 249)
  set the titleVisible of TagWD to 0
  set the modal of TagWD to 1
  tell TagWD
    UpdateFields()
    PlaceMySlider()
    init()
  end tell
  open(TagWD)
end

on OpenRenameWD theLine
  global RenameWD, CDfilePath, PCDEL
  set RenameWD to window (CDfilePath & "WDS" & PCDEL & "NC_RNAME.GEO")
  set the rect of RenameWD to rect(the stageLeft + 286, the stageTop + 87, the stageLeft + 526, the stageTop + 199)
  set the titleVisible of RenameWD to 0
  set the modal of RenameWD to 1
  tell RenameWD
    UpdateLine(theLine)
  end tell
  open(RenameWD)
end

on UpdateRenameWD theText
  global TagWD
  tell TagWD
    UpdateRename(theText)
  end tell
  CloseRenameWD()
end

on CloseRenameWD
  global RenameWD
  if objectp(RenameWD) then
    forget(RenameWD)
  end if
end

on OpenSureWD
  global SureWD, CDfilePath, PCDEL
  set SureWD to window (CDfilePath & "WDS" & PCDEL & "NC_SURE.GEO")
  set the rect of SureWD to rect(the stageLeft + 286, the stageTop + 87, the stageLeft + 526, the stageTop + 199)
  set the titleVisible of SureWD to 0
  set the modal of SureWD to 1
  open(SureWD)
end

on CloseSureWD
  global SureWD
  if objectp(SureWD) then
    forget(SureWD)
  end if
end

on ClearAllTags
  global CardTitles, TAGS_DATA, TAGS_TITLES, TAGS_LIST, TagWD
  CloseSureWD()
  set the castNum of sprite Get_MarkSprite() to the number of cast ("V_" & "UNMARK")
  set TAGS_LIST to []
  set TAGS_TITLES to EMPTY
  set TAGS_DATA to EMPTY
  tell TagWD
    UpdateFields()
    PlaceMySlider()
    init()
  end tell
  updateStage()
end

on CloseTagWindow
  global TagWD
  if objectp(TagWD) then
    forget(TagWD)
  end if
  set the cursor of sprite 48 to 0
  tell the stage
    continue()
  end tell
end

on GoTagMovie
  go("Init" & Get_ScreenSubject(), Get_TagMovie())
end

on Set_TagMovie theMovie
  global TagMovie
  set TagMovie to theMovie
end

on Get_TagMovie
  global TagMovie
  return TagMovie
end

on MarkScreen toMark
  global CardTitles, TAGS_DATA, TAGS_TITLES, TAGS_LIST
  set the castNum of sprite Get_MarkSprite() to the number of cast ("V_" & toMark)
  set movieName to the movieName
  if toMark = "MARK" then
    setAt(TAGS_LIST, count(TAGS_LIST) + 1, movieName)
    set LineNum to count(TAGS_LIST)
    set TheTitle to item Get_CDcounter() of line integer(Get_CurrentTool()) of CardTitles
    put TheTitle into line LineNum of TAGS_TITLES
    put movieName into item 1 of line LineNum of TAGS_DATA
    put Get_CurrentTool() into item 2 of line LineNum of TAGS_DATA
    put Get_ScreenSubject() into item 3 of line LineNum of TAGS_DATA
  else
    set itemNum to getOne(TAGS_LIST, movieName)
    deleteAt(TAGS_LIST, itemNum)
    delete line itemNum of TAGS_TITLES
    delete line itemNum of TAGS_DATA
  end if
  updateStage()
end

on UpdateMark
  global TAGS_LIST
  set movieName to the movieName
  if getOne(TAGS_LIST, movieName) then
    set the castNum of sprite Get_MarkSprite() to the number of cast "V_MARK"
  end if
end

on HandleSound
  global volumeWindow, CDfilePath, PCDEL
  if objectp(volumeWindow) then
    forget(volumeWindow)
  end if
  EnableBtn("SOUND", get_SOUNDSprite())
  set volumeWindow to window (CDfilePath & "WDS" & PCDEL & "NC_VOL.GEO")
  set the rect of volumeWindow to rect(the stageLeft + 445, the stageTop + 63, the stageLeft + 574, the stageTop + 126)
  set the titleVisible of volumeWindow to 0
  tell volumeWindow
    RestoreSoundStatus()
  end tell
  open(volumeWindow)
end

on handleQuit
  global QuitWindow, CDfilePath, PCDEL
  cursor(4)
  if objectp(QuitWindow) then
    forget(QuitWindow)
  end if
  set the cursor of sprite 48 to [400, 401]
  set QuitWindow to window (CDfilePath & "WDS" & PCDEL & "NC_QUIT.GEO")
  set the rect of QuitWindow to rect(the stageLeft + 162, the stageTop + 122, the stageLeft + 478, the stageTop + 358)
  set the titleVisible of QuitWindow to 0
  set the modal of QuitWindow to 1
  open(QuitWindow)
end

on handleHELP
  EnableBtn("HELP", get_HELPSprite())
  openHelpWd()
end

on openHelpWd
  global helpWD, lastFrame, CDfilePath, PCDEL
  set the cursor of sprite 48 to [400, 401]
  set helpWD to window (CDfilePath & "WDS" & PCDEL & "NC_HLP.GEO")
  set the rect of helpWD to rect(the stageLeft + 62, the stageTop + 28, the stageLeft + 586, the stageTop + 444)
  set the titleVisible of helpWD to 0
  set the modal of helpWD to 1
  open(helpWD)
  set lastFrame to the frame
  go("helpLoop")
end

on closeHelpWd
  global helpWD, lastFrame
  set the cursor of sprite 48 to 0
  forget(helpWD)
  go(lastFrame)
end

on HandleNEXT
  GoNext()
  EnableBtn("NEXT", get_NEXTSprite())
end

on HandleBACK
  EnableBtn("BACK", get_BACKSprite())
  EnableBtn("NEXT", get_NEXTSprite())
  HideLastStep()
  Set_NEXT(1)
  sound stop 2
  go("start")
end

on HandleGLOSSARY
  global DicWindow
  EnableBtn("GLOSSARY", Get_GLOSSARYSprite())
  set the cursor of sprite 48 to [400, 401]
  open(DicWindow)
  tell the stage
    pause()
  end tell
  tell DicWindow
    go(2)
  end tell
end

on closeGLOSSARYwindow
  set the cursor of sprite 48 to 0
  continue()
end

on closeNotePadWindow
  set the cursor of sprite 48 to 0
  continue()
end

on HandleNOTEPAD
  global NoteBookWindow, CDfilePath, PCDEL
  EnableBtn("NOTEPAD", Get_NOTEPADSprite())
  set the cursor of sprite 48 to [400, 401]
  if objectp(NoteBookWindow) then
    forget(NoteBookWindow)
  end if
  set NoteBookWindow to window (CDfilePath & "WDS" & PCDEL & "NC_PAD.GEO")
  set the rect of NoteBookWindow to rect(the stageLeft + 7, the stageTop + 247, the stageLeft + 209, the stageTop + 419)
  set NBRect to the rect of NoteBookWindow
  set x1 to getAt(NBRect, 1)
  set y1 to getAt(NBRect, 2)
  set x2 to getAt(NBRect, 3)
  set y2 to getAt(NBRect, 4)
  set the modal of NoteBookWindow to 1
  set the windowType of NoteBookWindow to 2
  set the titleVisible of window "NoteBook" to 0
  open(NoteBookWindow)
end

on createNoteBook
  global NBPrintWindow, CDfilePath, PCDEL
  if objectp(NBPrintWindow) then
    forget(NBPrintWindow)
  end if
  set NBPrintWindow to window (CDfilePath & "WDS" & PCDEL & "NC_PRINT.GEO")
  set StageRect to the rect of the stage
  set x1 to getAt(StageRect, 1)
  set y1 to getAt(StageRect, 2)
  set x2 to getAt(StageRect, 3)
  set y2 to getAt(StageRect, 4)
  set the rect of NBPrintWindow to rect(x1, y1, x1 + 640, y1 + 480)
  set NBRect to the rect of NBPrintWindow
  set the fileName of NBPrintWindow to "Auto Page SetUp"
  set the windowType of NBPrintWindow to 2
  open(NBPrintWindow)
end

on closePrintWindow
  RestoreHilites()
end

on closeQuitWindow
  global QuitWindow
  set the cursor of sprite 48 to 0
  forget(QuitWindow)
  continue()
end

on leaveApplication
  global QuitWindow, UsersData, TheBackWindow
  forget(QuitWindow)
  if the machineType <> 256 then
  end if
  quit()
end

on keyDown
  if not get_Disabled() then
    if the commandDown and ((the key = "q") or (the key = ".")) then
      handleQuit()
    else
      if (the keyCode = 76) or (the keyCode = 36) then
        HandleNEXT()
      else
        pass()
      end if
    end if
  else
    pass()
  end if
end

on CheckOpenWindow
  global volumeWindow
  if objectp(volumeWindow) then
    forget(volumeWindow)
    continue()
  end if
end

on CheckRollOver
  if rollOver(get_IndexSprite()) then
    set the castNum of sprite get_NavigatorHL() to the number of cast "Index-HL"
    set Hloc to the locH of sprite get_IndexSprite()
    set Vloc to the locV of sprite get_IndexSprite()
  else
    if rollOver(get_FindSprite()) then
      set the castNum of sprite get_NavigatorHL() to the number of cast "Find-HL"
      set Hloc to the locH of sprite get_FindSprite()
      set Vloc to the locV of sprite get_FindSprite()
    else
      if rollOver(Get_TagWdSprite()) then
        set the castNum of sprite get_NavigatorHL() to the number of cast "TagWD-HL"
        set Hloc to the locH of sprite Get_TagWdSprite()
        set Vloc to the locV of sprite Get_TagWdSprite()
      else
        set Hloc to EMPTY
      end if
    end if
  end if
  if Hloc <> EMPTY then
    set the locH of sprite get_NavigatorHL() to Hloc
    set the locV of sprite get_NavigatorHL() to Vloc
    set the visible of sprite get_NavigatorHL() to 1
    updateStage()
  else
    set the visible of sprite get_NavigatorHL() to 0
    updateStage()
  end if
end

on setDefaultCursor
  set cursorList to getCursorList()
  set counter to count(cursorList)
  repeat with i = 1 to counter
    set currItem to getAt(cursorList, i)
    if currItem <> 0 then
      set CursorCastNum to getCursor(currItem)
      set the cursor of sprite i to [CursorCastNum, CursorCastNum + 1]
    end if
  end repeat
end

on UpdateCursors theSp, theCursor
  global cursorList
  setAt(cursorList, theSp, theCursor)
  if theCursor = 0 then
    set the cursor of sprite theSp to theCursor
  else
    set CursorCastNum to getCursor(theCursor)
    set the cursor of sprite theSp to [CursorCastNum, CursorCastNum + 1]
  end if
end

on setEmptyCursor
  set cursorList to getCursorList()
  set counter to count(cursorList)
  repeat with i = 1 to counter
    set currItem to getAt(cursorList, i)
    if currItem <> 0 then
      set the cursor of sprite i to 0
      setAt(cursorList, i, 0)
    end if
  end repeat
end

on setCursorTool int
  global CursorTool
  set CursorTool to int
end

on initCursorCastNum
  global CursorCastNum
  set CursorCastNum to "400,402,404,406"
end

on getCursor cursorNum
  global CursorCastNum
  return integer(item cursorNum of CursorCastNum)
end

on initCursorList list
  global cursorList
  if list = 1 then
    set cursorList to [2, 3, 4, 0, 0, 4, 3, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 3, 3, 3, 3]
  end if
  setDefaultCursor()
end

on getCursorList
  global cursorList
  return cursorList
end

on ___BTNS_HANDLERS___
end

on switchButt spriteNum, castDown, macroName
  if getRollName() <> EMPTY then
    set spNum to EMPTY
    do("put get_" & getRollName() & "Sprite() into spNum")
    set the castNum of sprite spNum to the number of cast getRollName()
    setRollName(EMPTY)
  end if
  set flag to 0
  set SaveCast to the castNum of sprite spriteNum
  set flag to swapCast(spriteNum, SaveCast, castDown)
  repeat while the stillDown
    set flag to swapCast(spriteNum, SaveCast, castDown)
  end repeat
  if flag = 1 then
    sound stop 2
    do(macroName)
  end if
end

on swapCast spriteNum, SaveCast, castDown
  if rollOver(spriteNum) then
    set the castNum of sprite spriteNum to the number of cast castDown
    updateStage()
    return 1
  else
    set the castNum of sprite spriteNum to the number of cast SaveCast
    updateStage()
    return 0
  end if
end

on DisableBtn btnName, btnSprite
  set the castNum of sprite btnSprite to the number of cast (btnName & "_F")
end

on EnableBtn btnName, btnSprite
  set the castNum of sprite btnSprite to the number of cast btnName
end

on setRollName theName
  global RollName
  set RollName to theName
end

on getRollName
  global RollName
  return RollName
end

on Set_NOTEPADSprite theSp
  global NOTEPADSprite
  set NOTEPADSprite to theSp
end

on Get_NOTEPADSprite
  global NOTEPADSprite
  return NOTEPADSprite
end

on Set_GLOSSARYSprite theSp
  global GLOSSARYSprite
  set GLOSSARYSprite to theSp
end

on Get_GLOSSARYSprite
  global GLOSSARYSprite
  return GLOSSARYSprite
end

on Set_SoundSprite theSp
  global SoundSprite
  set SoundSprite to theSp
end

on get_SOUNDSprite
  global SoundSprite
  return SoundSprite
end

on Set_HelpSprite theSp
  global HelpSprite
  set HelpSprite to theSp
end

on get_HELPSprite
  global HelpSprite
  return HelpSprite
end

on Set_NEXTSprite theSp
  global NEXTSprite
  set NEXTSprite to theSp
end

on get_NEXTSprite
  global NEXTSprite
  return NEXTSprite
end

on Set_BACKSprite theSp
  global BACKSprite
  set BACKSprite to theSp
end

on get_BACKSprite
  global BACKSprite
  return BACKSprite
end

on Set_NavigatorHL theSp
  global NavigatorHL
  set NavigatorHL to theSp
end

on get_NavigatorHL
  global NavigatorHL
  return NavigatorHL
end

on Set_IndexSprite theSp
  global IndexSprite
  set IndexSprite to theSp
end

on get_IndexSprite
  global IndexSprite
  return IndexSprite
end

on Set_TagWDSprite theSp
  global TagWdSprite
  set TagWdSprite to theSp
end

on Get_TagWdSprite
  global TagWdSprite
  return TagWdSprite
end

on Set_FindSprite theSp
  global FindSprite
  set FindSprite to theSp
end

on get_FindSprite
  global FindSprite
  return FindSprite
end

on Set_MainSprite theSp
  global MainSprite
  set MainSprite to theSp
end

on get_MainSprite
  global MainSprite
  return MainSprite
end

on Set_NEXT theSp
  global next
  set next to theSp
end

on Get_NEXT
  global next
  return next
end

on Set_PlayDub theMode
  global PlayDub
  set PlayDub to theMode
end

on Get_PlayDub
  global PlayDub
  return PlayDub
end

on Set_ScreenSubject theNum
  global ScreenSubject
  set ScreenSubject to theNum
end

on Get_ScreenSubject
  global ScreenSubject
  return ScreenSubject
end

on set_MarkSprite theNum
  global MarkSprite
  set MarkSprite to theNum
end

on Get_MarkSprite
  global MarkSprite
  return MarkSprite
end

on setTimer int
  global theTime
  set theTime to int
end

on getTimer
  global theTime
  return theTime
end

on DisableBTNS
  global DisableMode
  set DisableMode to 1
end

on EnableBtns
  global DisableMode
  set DisableMode to 0
end

on get_Disabled
  global DisableMode
  return DisableMode
end
