on InitSnakelogic
  Set_SnakeSprite(3)
  Set_HLSprite(4)
  Set_TagSprite(40)
  Set_TagIsShown(0)
  Set_LastTag(0)
  set the puppet of sprite Get_TagSprite() to 1
  CreateSnakeGrid()
end

on CreateSnakeGrid
  Set_BoxSize(14)
  SetGridRef()
end

on CheckSnakeStatus
  if rollOver(Get_SnakeSprite()) then
    ShowTag()
  else
    if get_TagIsShown() then
      HideTag()
    end if
  end if
end

on RestoreHilites
  set theVec to Get_SeenINPath()
  repeat with i = 1 to the number of items in theVec
    if item i of theVec = 1 then
      set NumOfBox to i
      set tagVLoc to ((NumOfBox - 1) * get_BoxSize()) + get_GridRef(2)
      set the locH of sprite Get_HLSprite() to integer(get_GridRef(1))
      set the locV of sprite Get_HLSprite() to integer(tagVLoc)
      updateStage()
    end if
  end repeat
end

on ChooseScreen
  sound stop 2
  set themouseV to the mouseV
  set NumOfBox to integer(((themouseV - get_GridRef(2)) / get_BoxSize()) - 0.5) + 1
  set movieName to item NumOfBox of Get_CurrentSnakeScreens()
  if the number of chars in movieName = 8 then
    set tagVLoc to ((NumOfBox - 1) * get_BoxSize()) + get_GridRef(2)
    SaveHilite(NumOfBox)
    go("INIT" & Get_ScreenSubject(), movieName & ".GEO")
  end if
end

on SaveHilite NumOfBox
  Set_SeenINPath(1, Get_CDcounter())
end

on ShowTag
  set themouseV to the mouseV
  set NumOfBox to integer(((themouseV - get_GridRef(2)) / get_BoxSize()) - 0.5) + 1
  if get_LastTag() <> NumOfBox then
    Set_LastTag(NumOfBox)
    set tagVLoc to ((NumOfBox - 1) * get_BoxSize()) + get_GridRef(2) + integer(get_BoxSize() / 2)
    set the castNum of sprite Get_TagSprite() to the number of cast ("tag-" & NumOfBox)
    set the locH of sprite Get_TagSprite() to integer(get_GridRef(1)) - 3
    set the locV of sprite Get_TagSprite() to integer(tagVLoc)
    updateStage()
    Set_TagIsShown(1)
  end if
end

on HideTag
  Set_TagIsShown(0)
  Set_LastTag(0)
  set the locH of sprite Get_TagSprite() to 999
  set the locV of sprite Get_TagSprite() to 999
  updateStage()
end

on SetGridRef
  global GridRef
  put the locH of sprite Get_SnakeSprite() into item 1 of GridRef
  put the locV of sprite Get_SnakeSprite() into item 2 of GridRef
end

on get_GridRef theItem
  global GridRef
  return item theItem of GridRef
end

on Set_TagIsShown theSp
  global TagIsShown
  set TagIsShown to theSp
end

on get_TagIsShown
  global TagIsShown
  return TagIsShown
end

on Set_LastTag theSp
  global LastTag
  set LastTag to theSp
end

on get_LastTag
  global LastTag
  return LastTag
end

on Set_BoxSize theSp
  global BoxSize
  set BoxSize to theSp
end

on get_BoxSize
  global BoxSize
  return BoxSize
end

on Set_SnakeSprite theSp
  global SnakeSprite
  set SnakeSprite to theSp
end

on Get_SnakeSprite
  global SnakeSprite
  return SnakeSprite
end

on Set_HLSprite theSp
  global HLSprite
  set HLSprite to theSp
end

on Get_HLSprite
  global HLSprite
  return HLSprite
end

on Set_TagSprite theSp
  global TagSprite
  set TagSprite to theSp
end

on Get_TagSprite
  global TagSprite
  return TagSprite
end

on Set_CDcounter theNum
  global CDcounter
  set CDcounter to theNum
end

on Add_CDcounter theNum
  global CDcounter
  set CDcounter to theNum + CDcounter
end

on Get_CDcounter
  global CDcounter
  return CDcounter
end

on Set_SeenINPath theNum, theItem
  global SEENINPath
  if paramCount() = 2 then
    put theNum into item theItem of SEENINPath
  else
    set SEENINPath to theNum
  end if
end

on Get_SeenINPath theItem
  global SEENINPath
  if paramCount() = 1 then
    return item theItem of SEENINPath
  else
    return SEENINPath
  end if
end

on SaveSeenScreens
  SaveHilite()
  set toolNum to Get_CurrentTool()
  do("Set_WasInPathTool" & toolNum)
end

on Set_ScreensTool01 theMode
  global ScreensTool01
  set ScreensTool01 to theMode
end

on Get_ScreensTool01
  global ScreensTool01
  return ScreensTool01
end

on Set_ScreensTool02 theMode
  global ScreensTool02
  set ScreensTool02 to theMode
end

on Get_ScreensTool02
  global ScreensTool02
  return ScreensTool02
end

on Set_ScreensTool03 theMode
  global ScreensTool03
  set ScreensTool03 to theMode
end

on Get_ScreensTool03
  global ScreensTool03
  return ScreensTool03
end

on Set_ScreensTool04 theMode
  global ScreensTool04
  set ScreensTool04 to theMode
end

on Get_ScreensTool04
  global ScreensTool04
  return ScreensTool04
end

on Set_ScreensTool05 theMode
  global ScreensTool05
  set ScreensTool05 to theMode
end

on Get_ScreensTool05
  global ScreensTool05
  return ScreensTool05
end

on Set_ScreensTool06 theMode
  global ScreensTool06
  set ScreensTool06 to theMode
end

on Get_ScreensTool06
  global ScreensTool06
  return ScreensTool06
end

on Set_WasInPathTool01 theMode
  global WasInPathTool01
  set WasInPathTool01 to Get_SeenINPath()
end

on Get_WasInPathTool01
  global WasInPathTool01
  return WasInPathTool01
end

on Set_WasInPathTool02 theMode
  global WasInPathTool02
  set WasInPathTool02 to Get_SeenINPath()
end

on Get_WasInPathTool02
  global WasInPathTool02
  return WasInPathTool02
end

on Set_WasInPathTool03 theMode
  global WasInPathTool03
  set WasInPathTool03 to Get_SeenINPath()
end

on Get_WasInPathTool03
  global WasInPathTool03
  return WasInPathTool03
end

on Set_WasInPathTool04 theMode
  global WasInPathTool04
  set WasInPathTool04 to Get_SeenINPath()
end

on Get_WasInPathTool04
  global WasInPathTool04
  return WasInPathTool04
end

on Set_WasInPathTool05 theMode
  global WasInPathTool05
  set WasInPathTool015 to Get_SeenINPath()
end

on Get_WasInPathTool05
  global WasInPathTool05
  return WasInPathTool05
end

on Set_WasInPathTool06 theMode
  global WasInPathTool06
  set WasInPathTool06 to Get_SeenINPath()
end

on Get_WasInPathTool06
  global WasInPathTool06
  return WasInPathTool06
end

on Set_WasInPathTool07 theMode
  global WasInPathTool07
  set WasInPathTool07 to Get_SeenINPath()
end

on Get_WasInPathTool07
  global WasInPathTool07
  return WasInPathTool07
end

on Set_WasInPathTool08 theMode
  global WasInPathTool08
  set WasInPathTool08 to Get_SeenINPath()
end

on Get_WasInPathTool08
  global WasInPathTool08
  return WasInPathTool08
end

on Set_WasInPathTool09 theMode
  global WasInPathTool09
  set WasInPathTool09 to Get_SeenINPath()
end

on Get_WasInPathTool09
  global WasInPathTool09
  return WasInPathTool09
end

on Set_WasInPathTool10 theMode
  global WasInPathTool10
  set WasInPathTool10 to Get_SeenINPath()
end

on Get_WasInPathTool10
  global WasInPathTool10
  return WasInPathTool10
end

on Set_WasInPathTool11 theMode
  global WasInPathTool11
  set WasInPathTool11 to Get_SeenINPath()
end

on Get_WasInPathTool11
  global WasInPathTool11
  return WasInPathTool11
end

on Set_WasInPathTool12 theMode
  global WasInPathTool12
  set WasInPathTool12 to Get_SeenINPath()
end

on Get_WasInPathTool12
  global WasInPathTool12
  return WasInPathTool12
end

on Set_WasInPathTool13 theMode
  global WasInPathTool13
  set WasInPathTool13 to Get_SeenINPath()
end

on Get_WasInPathTool13
  global WasInPathTool13
  return WasInPathTool13
end

on Set_CurrentTool theMode
  global CurrentTool
  set CurrentTool to theMode
end

on Get_CurrentTool
  global CurrentTool
  return CurrentTool
end

on Set_CurrentSnakeScreens theMode
  global CurrentSnakeScreens
  set CurrentSnakeScreens to theMode
end

on Get_CurrentSnakeScreens
  global CurrentSnakeScreens
  return CurrentSnakeScreens
end
